function cv = CrossValidation(lambda, s, distribution, wtrans, wname, NL, ...
              max_IP_iter, IP_optimal_tol, feasible_tol, ...
              max_CG_iter, CG_tol)

N = length(s);
s1=s(1:2:N);
s2=s(2:2:N);

lambda=exp(lambda);
[x1, coef_hat, lambda1, history_iter, x_save,y_save,z_save,eta_save,rho_save] = ...
GBP(s1, lambda, distribution, wtrans, wname, NL, ...
    max_IP_iter, IP_optimal_tol, feasible_tol, ...
    max_CG_iter, CG_tol,...
    0,0,0,0,0,2);

x1c=x1;
x1c(end)=[];
x2hat=(2*x1c+diff(x1))/2;

[x2, coef_hat, lambda2, history_iter, x_save,y_save,z_save,eta_save,rho_save] = ...
GBP(s2, lambda, distribution, wtrans, wname, NL, ...
    max_IP_iter, IP_optimal_tol, feasible_tol, ...
    max_CG_iter, CG_tol,...
    0,0,0,0,0,2);

x2c=x2;
x2c(end)=[];
x1hat=(2*x2c+diff(x2))/2;

cv=mean(-log(x2hat).*s2(1:length(x2hat))+x2hat)+mean(-log(x1hat).*s1(2:(length(x1hat)+1))+x1hat);


