function [rx, ry, rz, reta] = ...
KKT_conditions(x, y, z, eta, s, rho, LS, nA, n0, distribution, wtrans, wname, PO_qmf, NL, signal_dim, inequality_constant)

[Aty, LS, Phi_0ty] = trans_A_mat(y, s, distribution, wtrans, wname, PO_qmf, NL, signal_dim);
rx = -Aty + inequality_constant - z;
[s_hat, coef_hat, s_hat_coef] = reconstruct_signal(x, y, s, eta, LS, nA, n0, distribution, wtrans, wname, PO_qmf, NL, signal_dim);
ry = -s_hat_coef + s_hat;
switch distribution
  case 'poisson'
    n = size(ry,1)*size(ry,2);
    xs0 = zeros(1, n);
    xs0(s==0) = x(1: n0);
    ry = ry + reshape(xs0, size(ry,1), size(ry,2));
end
rz = rho - z .* x;
reta = -Phi_0ty;

