function [C, LS] = analysis(y, wtrans, wname, PO_qmf, NL, signal_dim)

switch signal_dim
  case 1
    switch wtrans
      case 'wavedec'
        [C, LS] = wavedec(y, NL, wname);
      case 'FWT_PO'
        C = FWT_PO(y, NL, PO_qmf);
        LS = [2^NL length(y)];
    end
  case 2
    switch wtrans
      case 'wavedec2'
        [C, LS] = wavedec2(y, NL, wname);
      case 'FWT2_PO'
        C = FWT2_PO(y, NL, PO_qmf);
        NL1=NL;NL2=NL;
        LS = [2^NL1 2^NL2; size(y,1) size(y,2)];
        Phi_0ty=reshape(C(1:LS(1,1),1:LS(1,2)), 1, LS(1,1)*LS(1,2));
        C(1:LS(1,1), 1:LS(1,2))=Inf;
        Cm=C(C~=Inf)';
        C=[Phi_0ty Cm];
    end
  otherwise
    error('The signal must be 1D or 2D')
end
