function [s_hat, coef_hat, dcf, pcf, primal_feasible, dual_feasible, duality_gap, feasible, converged] = ...
check_convergence(s, x, y, z, eta, rho, feasible_tol, IP_optimal_tol, LS, nA, n0, length_father, distribution, wtrans, wname, PO_qmf, NL, signal_dim, inequality_constant)

[s_hat, coef_hat]=reconstruct_signal(x, y, s, eta, LS, nA, n0, distribution, wtrans, wname, PO_qmf, NL, signal_dim);

pcf = primal_cost(s, x, y, eta, LS, nA, n0, length_father, distribution, wtrans, wname, PO_qmf, NL, signal_dim, inequality_constant);
dcf = dual_cost(y, s, distribution);

[rx, ry, rz, reta] = KKT_conditions(x, y, z, eta, s, rho, LS, nA, n0, distribution, wtrans, wname, PO_qmf, NL, signal_dim, inequality_constant);

primal_feasible = norm(ry)/(1 + sqrt(norm(x)^2+norm(eta)^2));
dual_feasible = max( norm(rx)/(1 + norm(y)), norm(reta)/(1 + norm(y)));
duality_gap = sum(z .* x)/(1 + norm(x) * norm(z));
feasible = (primal_feasible < feasible_tol) & (dual_feasible < feasible_tol);
converged = (duality_gap < IP_optimal_tol);
