function [distribution, s, M, N, signal_dim, PO_Type, PO_Par, PO_qmf] = ...
check_initial_variables(s, lambda, distribution, wtrans, wname, NL, signal_dim)

if(~isreal(lambda) | (lambda < 0))
  error('!!! lambda must be real and positive!');
end
M=size(s, 1); N=size(s, 2);
if((M>1) & (N>1))
  signal_dim=2;
else
  if(N==1)
    s=s';N=M;M=1;
  end
  signal_dim=1;
end
switch wtrans
  case {'wavedec', 'FWT_PO'}
    if(~signal_dim==1) error('Need a 2D wavelet transform')
    end
  case {'wavedec2', 'FWT2_PO'}
    if(~signal_dim==2) error('Need a 1D wavelet transform')
    end
  otherwise
    error('Non-supported wavelet transform in GBP')
end
if(strcmp(wtrans,'FWT_PO') | strcmp(wtrans,'FWT2_PO'))
  switch wname
    case {'ha'}
      PO_Type='Haar';
      PO_Par='0';
    case 'db'
      PO_Type='Daubechies';
      PO_Par='4';
    case {'co'}
      PO_Type='Coiflet';
      PO_Par='3';
    case 'sy'
      PO_Type='Symmlet';
      PO_Par='8';
    otherwise
      error('Non-supported wavelet type/name')
  end
  PO_Par=str2num(PO_Par);
  PO_qmf = MakeONFilter(PO_Type, PO_Par);
else
  PO_Type=[]; PO_Par=[]; PO_qmf=[];
end

switch distribution
  case {'gaussian', 'Gaussian', 'normal', 'Normal'}
        distribution = 'gaussian';
  case {'poisson', 'Poisson'}
        distribution = 'poisson';
  case {'spectral', 'Spectral'}
        distribution = 'spectral';
  otherwise
        error('Non-supported distribution')
end
