function [beta_x, beta_y, beta_z, beta_eta] = ...
length_Newton_step(s, x, y, z, eta, dx, dy, dz, deta, ...
                   wtrans, wname, PO_qmf, NL, ...
                   signal_dim, inequality_constant, ...
                   LS, nA, n0, distribution, ...
                   length_father)
%% Find the longest Newton step while remaining feasible.
beta_x=1; beta_y=1; beta_z=1; beta_eta=1;
% x>0 and z>0 must remain positive
negdx = logical(dx < 0);
negdz = logical(dz < 0);
if(any(negdx))
  beta_x = min(x(negdx)./abs(dx(negdx)));
end
if(any(negdz))
  beta_z = min(z(negdz)./abs(dz(negdz)));
end
switch distribution
  case 'gaussian'
  case 'poisson'
    negdy = logical(dy < 0);
    if(any(any(negdy)))
      beta_y = min([beta_y min((-1-y(negdy))./dy(negdy))]);
    end
end
beta_y = min(beta_y, beta_z);
beta_z=beta_y;








