function lou = linear_operator_ortho(u, s, d_diag, p_diag, LS, nA, n0, length_father, distribution, wtrans, wname, PO_qmf, NL, M, N, signal_dim)

% u must be a column vector
nd = (length(d_diag)-n0)/2;
d1 = d_diag(n0+(1:nd));
d2 = d_diag((n0+nd)+(1:nd));

u0 = [zeros(1, length_father) u'];
Phiu = synthesis(u0, LS, wtrans, wname, PO_qmf, NL, signal_dim);
Phiu = reshape(Phiu, 1, M*N);
p_Phiu = p_diag .* Phiu;
s0_reshaped = reshape(s==0, 1, M*N);
switch distribution
  case 'poisson'
    if(n0 > 0)	
      d0 = d_diag(1:n0);
      A0t_Phiu = Phiu(s0_reshaped);
      d0_A0t_Phiu=d0 .* A0t_Phiu;
    else
      d0_A0t_Phiu=[];
    end
    nzeros = zeros(1, M*N); 
    nzeros(s0_reshaped) = d0_A0t_Phiu;
    p_Phiu = p_Phiu + nzeros;
end
p_Phiu=reshape(p_Phiu, M, N);
[C, LS] = analysis(p_Phiu, wtrans, wname, PO_qmf, NL, signal_dim);
C(1:length_father) = [];
lou = C + (d1+d2) .* u';
lou=lou';
