function lksx = lkshift(x,k)

%lkshift.m: 	Performs a circular shift of input vector by k units to the left.
% Usage     
%               lksx = lkshift(x,k) 
% Inputs 
%     x         Input vector (of length n).
%     k         Number of shifts.
% Outputs
%     lsx       Output vector, shifted version of x by k units to the left.

n = length(x);
lksx = [ x(k+1:n) x(1:k) ];

% Copyright (c) 2002
%
% Panagiotis Besbeas
% Institute of Mathematics and Statistics
% University of Kent at Canterbury
% Canterbury, Kent CT2 7NF
% United Kingdom
%
% mailto: P.T.Besbeas@ukc.ac.uk
%
% and
%
% Italia De Feis
% Istituto per le Applicazioni del Calcolo "Mauro Picone" 
% sezione di Napoli - CNR
% Via Pietro Castellino 111
% 80131 Napoli
% Italy
%
% mailto: defeis@iam.na.cnr.it
%
% and
%
% Theofanis Sapatinas
% Department of Mathematics and Statistics
% University of Cyprus
% P.O. Box 20537  
% CY 1678 Nicosia
% Cyprus
%
% mailto: T.Sapatinas@ucy.ac.cy 
