function logL = loglikelihood(shat, s, distribution)

size_shat = size(shat);
size_s = size(s);
total_length = size(s, 1) * size(s, 2);
if(size_shat ~= size_s)
  error('shat and s have different sizes');
else
  shat = reshape(shat, 1, total_length);
  s = reshape(s, 1, total_length);
end
switch distribution
  case 'gaussian'
    logL = -.5 * norm(s-shat)^2;
  case 'poisson'
    index_s0=(s==0); s0=s; shat0=shat;
    s0(index_s0)=[]; shat0(index_s0)=[];
    logL = sum(sum(s0 .* log(shat0))) - sum(sum(shat));
  otherwise
    error('Unsupported distribution');
end
