function lsx = lshift(x)

%lshift.m: 	Performs a circular shift of input vector by one unit to the left.
% Usage     
%           lsx = lshift(x) 
% Inputs
%     x     Input vector (of length n).
% Outputs
%     lsx   Output vector, shifted version of x by one unit to the left.

n = length(x);
lsx = [ x(2:n) x(1) ];

% Copyright (c) 1997.
%
% Eric Kolaczyk, 
% Department of Mathematics and Statistics
% Boston University
% 111 Cummington Avenue
% Boston, MA 02215
% USA
%
% mailto: kolaczyk@math.bu.edu 
%
% Revised: 01/09/05
