function out = present_results(x, y, s, s_hat, coef_hat, history_iter)

nrow = size(history_iter, 1);
iter = [1:nrow];
history_iter = [iter', history_iter];

% Written 
fprintf(1, '\nCost function:\n');
fprintf(1, '%2d) Dual: %10.4g ; Primal: %10.4g\n', history_iter(:,1:3)');

fprintf(1, '\nFeasibility convergence:\n');
fprintf(1, '%2d) Pfeas: %10.4g ; Dfeas: %10.4g ; Gap: %10.4g ; Mu: %10.4g\n', history_iter(:,[1,4,5,6,7])');

fprintf(1, '\nLength of Newton step:\n');
fprintf(1, '%2d) beta_x: %10.4g ; beta_y: %10.4g ; beta_z: %10.4g\n', history_iter(:,[1,8,9,10])');

fprintf(1, '\nConstraints violation:\n');
fprintf(1, '%2d) equal: %10.4g ; inequal: %3d ; x<=0: %3d ; z<=0: %3d\n', history_iter(:,[1,11,12,13,14])');

fprintf(1, '\nConjugate Gradient report:\n');
fprintf(1, '%2d) flag: %3d ; #iter: %3d ; relres: %10.4g\n', history_iter(:,[1,15,17,16])');
fprintf(1, '\n');

hold off
% Graphical
M=size(s, 1); N=size(s, 2);
if((M>1) & (N>1))
  signal_dim=2;
  subplot(2,2,1)
  mesh(s)
  subplot(2,2,2)
  mesh(y)
  subplot(2,2,3)
  plot(history_iter(:,2:3))
  subplot(2,2,4)
  mesh(s_hat)
else
  if(N==1)
    s=s';N=M;M=1;
  end
  signal_dim=1;
  subplot(2,2,1)
  plot(x,s, '.k')
  subplot(2,2,2)
  plot(x,y, '-b')
  subplot(2,2,3)
  plot(history_iter(:,2:3))
  subplot(2,2,4)
  plot(x,y, '-b')
  hold on
  plot(x,y, '-b')
  plot(x,s_hat, '-r')
  hold off
end




