function printFigure(k,file)

% printFigure: Saves current figure window contents as a colour EPS ( -depsc ) file or etc.  
%              This is of general use.
% Usage        printFigure(k,file)
% Inputs
%    k         Indicates the type of wanted figure (eps colour, eps b&w, ps colour, etc.). 
%   file       Name of the file containing the figure.

set(gcf,'papertype','A4');
set(gcf,'paperposition',[1, 0.5, 6.5, 11.0]);

%set(gcf,'paperpositionmode','auto'); % Should preseve wysiwig geometry.
%set(gcf,'inverthardcopy','off'); % Should leave black as black and white as white in EPS

qList = {'EPS (colour)', 'EPS (b&w)',  'PS (colour)',  'PICT',   'JPEG',   'Printer (colour)', 'Printer (b&w)'};

%devList={'-depsc -loose -adobecset -cmyk ',      '-deps -loose -adobecset ',  '-dpsc2 -loose -adobecset -cmyk ',     '-dpict',   '-djpeg',  '-dpsc2 -cmyk ', '-dps2'};
devList={'-depsc -loose -adobecset -cmyk ',      '-deps',  '-dpsc2 -loose -adobecset -cmyk ',     '-dpict',   '-djpeg',  '-dpsc2 -cmyk ', '-dps2'};
fileList={'file',        'file',        'file',        'file',   'file',    'printer',          'printer'};
sufList ={'*.eps',       '*.eps',       '*.ps',        '*.pict',  '*.jpeg'};

if nargin < 1,
   k=menu('Send to what device?',qList);
end

if strcmp(fileList{k},'file')
   if nargin < 2
      [fullFileName,path] = uiputfile(sufList{k}, ['Choose a name for your ' qList{k} ' file...']);
      if (fullFileName == 0)
         return; %Cancel button selected, load canceled.
      end%if file cancelled
      file =['''' path fullFileName ''' '];    
   end%if interactive mode
end%if file
eval(['print ' devList{k} ' ' file ' ']);
disp([' Figure printed to ' devList{k} ' on ' fileList{k} ' ' file]); 