function rsx = rshift(x)

% rshift.m:  Performs a circular shift of input vector by one unit to the right.
% Usage      
%            rsx = rshift(x)
% Inputs
%    x       Input vector (of length n).
% Outputs
%    rsx     Output vector, shifted version of x by one unit to the right.

n = length(x);
rsx = [ x(n) x(1:(n-1)) ];

% Copyright (c) 1997
%
% Eric Kolaczyk, 
% Department of Mathematics and Statistics
% Boston University
% 111 Cummington Avenue
% Boston, MA 02215
% USA
%
% mailto: kolaczyk@math.bu.edu 
%
% Revised: 01/09/05

