function rs = synthesis(C, LS, wtrans, wname, PO_qmf, NL, signal_dim)

switch signal_dim
  case 1
    switch wtrans
      case 'wavedec'
        rs = waverec(C, LS, wname);
      case 'FWT_PO'
        rs = IWT_PO(C, NL, PO_qmf);
    end
  case 2
    switch wtrans
      case 'wavedec2'
        rs = waverec2(C, LS, wname);
      case 'FWT2_PO'
        wt_father=C(1:LS(1,1)*LS(1,2));
        wt_mother=C((LS(1,1)*LS(1,2)+1): LS(end,1)*LS(end,2));
        x2 = ones(LS(end,1), LS(end,2));
        x2(1:LS(1,1),1:LS(1,2))=0;
        x3=logical(x2);
        x2(x3)=wt_mother;
        x2(~x3)=wt_father;
        rs = IWT2_PO(x2, NL, PO_qmf);
    end
  otherwise
    error('The signal must be 1D or 2D');
end
